import { WrapElementHandle } from "puppeteer";
/**
 * Puppeter JQuery interface
 * TODO map and test most of https://api.jquery.com/
 */
export interface PJQuery {
    add(selector?: string): PJQuery;
    add(html?: string): PJQuery;
    addClass(className: string): PJQuery;
    addClass(fnc: (index: number, currentClassName: string) => String): PJQuery;
    append(content?: string): PJQuery;
    append(content: (index: number, html: string) => string): PJQuery;
    addBack(selector?: string): PJQuery;
    addClass(className: String): this;
    attr(attributeName: string): Promise<string>;
    attr(attributeName: string, value: string): this;
    children(selector?: string): PJQuery;
    closest(selector?: string): PJQuery;
    css(propertyName: string): Promise<string>;
    css(propertyNames: string[]): Promise<string[]>;
    css(properties: {
        [keys: string]: string | number;
    }): this;
    css(propertyName: string, value: string | number): this;
    css(propertyName: string, value: (index: number, value: string) => string | number): this;
    find(selector?: string): PJQuery;
    first(): PJQuery;
    html(): Promise<string>;
    html(test: string): PJQuery;
    is(className: String): Promise<boolean>;
    last(): PJQuery;
    map(mapping: (index: number, element: any) => any): PJQuery;
    next(selector?: string): PJQuery;
    nextAll(selector?: string): PJQuery;
    nextUntil(selector?: string): PJQuery;
    parent(selector?: string): PJQuery;
    parents(selector?: string): PJQuery;
    parentsUntil(selector?: string): PJQuery;
    prev(selector?: string): PJQuery;
    prevAll(selector?: string): PJQuery;
    prevUntil(selector?: string, filter?: string): PJQuery;
    prop(attributeName: string): Promise<string>;
    prop(attributeName: string, value: string): this;
    removeAttr(attributeName: string): this;
    removeProp(attributeName: string): this;
    removeClass(className: String): this;
    siblings(selector?: string): PJQuery;
    text(): Promise<string>;
    text(test: string): PJQuery;
    val(): Promise<string>;
    val(test: string): PJQuery;
    exec(): Promise<WrapElementHandle<any>[]>;
    pojo(): Promise<any[]>;
}
